; CS-301 - Programming Assignment 4
; Author:  Tim Potter
; Date Due: 4/3/07

.386
.MODEL FLAT

ExitProcess PROTO NEAR32 stdcall, dwExitCode:DWORD

GetStdHandle PROTO NEAR32 stdcall,
	nStdHandle:DWORD
	
WriteFile PROTO NEAR32 stdcall,
	hFile:DWORD, lpBuffer:NEAR32, nNumberOfCharsToWrite:DWORD,
	lpNumberOfBytesWritten:NEAR32, lpOverlapped:NEAR32

CreateFileA PROTO NEAR32 stdcall,
	lpFileName:NEAR32, access:DWORD, shareMode:DWORD,
	lpSecurity:NEAR32, creation:DWORD, attributes:DWORD, copyHandle:DWORD
	
CloseHandle PROTO NEAR32 stdcall,
	fHandle:DWORD

INCLUDE io.h

STD_OUTPUT		EQU	-11
GENERIC_WRITE	EQU	40000000h
CREATE_ALWAYS	EQU	2
cr				EQU	0dh
lf				EQU	0ah

.STACK	8192

.DATA

	AR1		WORD	30 DUP (?)
	AR2		WORD	30 DUP (?)
	num		WORD	?
	oput	BYTE	6 DUP (?)
	strIn	WORD	6 DUP (?)	
	nextLn	BYTE	cr,lf
	fName	BYTE	"prg4out.txt",0
	written	DWORD	?
	hStdOut	DWORD	?
	hFile	DWORD	?
	
	lineOut	BYTE	"Welcome to the Prime # Generator",cr,lf,lf,lf
			BYTE	"This program will generate the next 30",cr,lf
			BYTE	" prime numbers after the requested value",cr,lf,lf
	prompt	BYTE	"Please enter a positive 4 digit integer: ",cr,lf,lf,lf
	fileOut	BYTE	"Generated Prime Numbers after "
	endOut	BYTE	"All numbers generated... check output file",cr,lf,lf
			BYTE	"Bye ...",cr,lf
	
	
	
	
.CODE
IsPrimeOrNot	PROC	NEAR32
; BX is coming with a number and this proc checks if this number is prime or not. If yes, BX returns unchanged, else BX returns 0.
; BE SURE TO RESTORE OTHER REGISTERS (pushad and popad)

	pushad					; Saving register  values from calling proc
	
	mov		cx,2

tester:	
	mov		ax,bx
	cmp		cx,ax			; Compare divisor and testing number, if equal, all divisors have been tested.
	je		prime
	sub 	dx,dx
	div		cx
	cmp		dx,0			; Is the remainder 0? 
	je		notprime		; --return BX as 0
	inc		cx				; Next Divisor
	jmp		tester			; Loop
	

prime:
	popad					; Restoring register values, leaving BX unchanged
	ret
	
notprime:	
	popad					; Restoring register and flag values, then modifying BX to 0
	mov		bx,0
	ret
IsPrimeOrNot	ENDP


GetPrimeNums	PROC	NEAR32
; SI is coming with a number and this proc has to generate 30 prime #'s that are larger than this. EDI is bringing the address of
; an array of 30 Words in which the prime numbers are to be stored.  For every potential #, this proc loads it into BX and calls
; IsPrimeOrNot to check if its prime or not.  If yes, # is stored in the array, else the next # is tried.
; BE SURE TO RESTORE ALL REGISTERS
	
	pushad					; Saving register values from calling proc
	
	mov		ecx,30			; Loop 30 times to get prime #'s
	
next:
	inc		si				; Prepare next testing number	
	mov		bx,si			; Start testing with first potential number
	call	IsPrimeOrNot	; Test for prime
	cmp		bx,0			; Was the potential number a prime?
	je		next			; No? - Try next potential number
	mov		[edi],bx		; Yes? - Put prime number in array
	add		edi,2			; move pointer to next array element
	
	loop	next			; try next potential number and decrement ECX
	
	popad					; Restoring register values
	ret						; Once all primes are found, return to caller
GetPrimeNums	ENDP


WritePrimeNums	PROC	NEAR32
; EDI is pointing to an array of 30 Words and this proc has to write numbers from this array to a file, 5 to a line.
; BE SURE TO RESTORE ALL REGISTERS
	
	pushad					; Saving register values from calling proc

	mov		ax,5			; line counter

next:
	mov		cx,[edi]		; Store number in register
	itoa	oPut,cx			; convert prime to ASCII
	
	
	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR oPut,	
		6,					; fileout length
		NEAR32 PTR written,
		0


	inc		ax
	push	ax				; save counter
	
	sub		dx,dx
	mov		bx,5			; set divisor to 5
	
	div		bx
	cmp		dx,0			; does counter divide into 5?
	je		newline			
newlineback:	
	pop		ax
	cmp		ax,35
	jge		endprint
	add		edi,2			; go to next array element
	jmp 	next

	
newline:
	INVOKE WriteFile,		; next line
		hFile,				
		NEAR32 PTR nextLn,	
		2,					
		NEAR32 PTR written,
		0
		
	jmp		newlineback
	
endprint:	
	popad
	ret
	
WritePrimeNums	ENDP


_start:

	INVOKE CreateFileA,		; open file
		NEAR32 PTR fName,	; file name
		GENERIC_WRITE,		; access
		0,					; no sharing
		0,					; no predefined security
		CREATE_ALWAYS,		; open if file doesn't exist
		0,					; no special attributes
		0					; no copied handle
		mov hFile, eax		; handle for file
		

	INVOKE GetStdHandle,	; Prepare output
		STD_OUTPUT			;   --  to screen
	mov hStdOut, eax
		
	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR lineOut,	
		164,				; lineout and prompt
		NEAR32 PTR written,	
		0
	
	input	strIn, 6		; Read 4 digit # into strIn (6 ascii # max)
	atoi	strIn			; Convert ascii to doubleword
	mov		num,ax			; Store in num
	mov		si,num			; copy to tester value
	
	lea		EDI,AR1			; Stores location of array1 to EDI
	
	call	GetPrimeNums

	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR fileOut,	
		30,					; fileout length
		NEAR32 PTR written,
		0

	call	WritePrimeNums
	
	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR prompt,	
		45,					; prompt
		NEAR32 PTR written,	
		0
	
	input	strIn, 6		; Read 4 digit # into strIn (6 ascii # max)
	atoi	strIn			; Convert ascii to doubleword
	mov		num,ax			; Store in num
	mov		si,num			; copy to tester value
	
	lea		EDI,AR2			; Stores location of array1 to EDI
	
	call	GetPrimeNums

	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR fileOut,	
		30,					; fileout length
		NEAR32 PTR written,
		0

	INVOKE WriteFile,		; user entered # with 8 to access cr,lf
		hFile,				
		NEAR32 PTR strIn,	
		6,					
		NEAR32 PTR written,
		0
	
	call	WritePrimeNums
	

closing:	
	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR endOut,	
		54,					; lineout and prompt
		NEAR32 PTR written,	
		0
	
	INVOKE	CloseHandle,	; close output file
		hFile
		
	INVOKE	ExitProcess, 0	; exit with return code of 0
	
PUBLIC _start				; make entry point public

END							; end of source code
	
	
